<template>
<div class="rtx-player">
	<div v-if="input" :class="classes">
		<div class="options" v-if="state === 0">
			<div
				v-for="(body, index) in bodies"
				:class="getBodyClasses(index)"
				:key="body.id"
			>{{ body.name }}</div>
		</div>
		<div class="options" v-else-if="state === 1 || state === 2">
			<div
				v-for="(ultimate, index) in ultimates"
				:class="getBodyClasses(index)"
				:key="ultimate.id"
			>{{ ultimate.name }}</div>
		</div>
		<div class="options" v-else>
			P{{ this.id + 1 }} Ready
		</div>
	</div>
	<div v-else>
		Press <control device="xbox" type="a" /> to connect
	</div>
</div>
</template>

<script>
import Control from "./Control.vue"
import Vue from "vue"

import { BODY_MESHES } from "../../constants/car.js"
import ULTIMATES from "../../../common/constants/Ultimates.js"

const STATE_BODY = 0
const STATE_POWER_1 = 1
const STATE_POWER_2 = 2
const STATE_READY = 3

export default {
	components: {
		Control
	},
	computed: {
		bodies () {
			return BODY_MESHES.map((body, index) => {
				return {
					id: body.id,
					index: index,
					name: body.name
				}
			})
		},
		classes () {
			const odd = this.id % 2 !== 0;
			return {
				"box": true,
				"even": !odd,
				"odd": odd,
			}
		},
		id () {
			return +this.name - 1
		},
		input () {
			return window.Input.list[this.name - 1]
		},
		ultimates () {
			return ULTIMATES.filter((ultimate) => {
				return ultimate.id !== this.ultimate_1
			})
		}
	},
	data () {

		return {
			body: null,
			counter: 0,
			lastA: true,
			lastB: true,
			lastX: 0,
			position: 0,
			start: true,
			state: STATE_READY,
			ultimate_1: "ULTIMATE_ANTI_ENERGY",
			ultimate_2: "ULTIMATE_PULSE",
			ultimate_3: "ULTIMATE_OVERCHARGE",
		}
	},
	methods: {
		emitState () {
			this.$emit("change", {
				body: this.body,
				id: this.id,
				ready: this.state === STATE_READY,
				ultimate_1: this.ultimate_1,
				ultimate_2: this.ultimate_2,
				ultimate_3: this.ultimate_3,
			})
		},
		getBodyClasses (id) {
			return {
				"item": true,
				"selected": id === this.position
			}
		},
		loop () {
			Vue.nextTick(() => {
				if (this.input) {
					if (!this.hasInput) {
						this.hasInput = true
						this.emitState()
					}

					// Detect LR analog stick
					let lr = 0
					const sign = Math.sign(this.input.get(CONTROLS.LX))
					if (sign !== this.lastX) {
						if (sign === 1) lr++
						if (sign === -1) lr--

						switch (this.state) {
							case STATE_BODY:
								this.position = Math.max(0, Math.min(this.bodies.length - 1, this.position + sign))
								break
							case STATE_POWER_1:
							case STATE_POWER_2:
								this.position = Math.max(0, Math.min(this.ultimates.length - 1, this.position + sign))
								break
						}

						Sound.playSFX("change_option")
					}
					this.lastX = sign

					const start = this.input.get(CONTROLS.MENU_START)
					this.emitState()
					if (this.state === STATE_READY && start && !this.start) this.$emit("start")
					this.start = start

					// Detect pressing A
					const a = this.input.get(CONTROLS.MENU_ACCEPT)
					if (a && !this.lastA) {
						switch (this.state) {
							case STATE_BODY:
								this.body = this.bodies[this.position].id
								break
							case STATE_POWER_1:
								this.ultimate_1 = this.ultimates[this.position].id
								break
							case STATE_POWER_2:
								this.ultimate_2 = this.ultimates[this.position].id
								break
						}

						if (this.state < STATE_READY) {
							this.position = 0
							this.state++
						}

						Sound.playSFX("select_option")

						this.emitState()
					}
					this.lastA = a
				}

				window.setTimeout(() => {
					this.loop()
				}, 1)
			})
		}
	},
	mounted () {
		this.loop()
	},
	name: "player",
	props: [ "name" ]
}
</script>

<style lang="less" scoped>
.box {
	align-items: center;
	display: flex;
	height: 10em;
	justify-content: center;
	width: 20em;
}

.even {
	background-color: #fbb;
	border: 2px #eaa solid;
}

.item {
	&.selected {
		border-color: #333;
	}

	border: .125em rgba(0, 0, 0, 0) solid;
	box-sizing: border-box;
	margin: .25em;
	padding: .25em;
}

.odd {
	background-color: #bbf;
	border: 2px #aae solid;
}

.options {
	display: flex;
}

.rtx-player {
	align-items: center;
	color: #333;
	display: flex;
	flex: 1;
	font-size: 4em;
	justify-content: center;
	text-shadow: none;
}
</style>
